package space.kklochko.jdbc_hospital_example.cli.commands;

import lombok.Data;
import space.kklochko.jdbc_hospital_example.db.repositories.AbstractRepository;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

@Data
public class CommandEntity <A, T> {
    private AbstractRepository<T> repository;
    private Method method;
    private A argument;

    public CommandEntity(AbstractRepository<T> repository, Method method, A argument) {
        this.repository = repository;
        this.method = method;
        this.argument = argument;
    }

    public boolean run() {
        try {
            return (Boolean) method.invoke(getRepository(), getArgument());
        } catch (InvocationTargetException e) {
            System.err.println(e.getMessage());
            throw new RuntimeException(e);
        } catch (IllegalAccessException e) {
            System.err.println(e.getMessage());
            throw new RuntimeException(e);
        }
    };
}
